'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = parseHTML;

var _parseDom = require('./parseDom');

var _parseDom2 = _interopRequireDefault(_parseDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function text(element) {
  return element.textContent || element.innerText;
}

function parseHTML(source) {
  if (!source) {
    return null;
  }

  var findCode = source.match(/<!-+ ?start-code ?-+>([\s\S]+?)<!-+ ?end-code ?-+>/gi);
  var code = {};

  if (!findCode) {
    return {
      beforeHTML: source
    };
  }

  findCode.forEach(function (item, index) {
    code['example-' + index] = text((0, _parseDom2.default)(item));
  });
  var beforeHTML = source.match(/([\s\S]+?)<!-+ ?start-code ?-+>/gi)[0];
  var afterHTML = source.match(/<!-+ ?parameter-description ?-+>([\s\S]+)/gi);

  return {
    code: code,
    beforeHTML: beforeHTML,
    afterHTML: afterHTML
  };
}